local ElvUI_EltreumUI, E, L, V, P, G = unpack(select(2, ...))

-- Exorsus Raid Tools profile setup
function ElvUI_EltreumUI:GetMRTProfile()
	if VMRT.Profiles.Eltreum then
		local key = tostring(E.myname).."-"..tostring(E.myrealm)
		table.insert(VMRT.ProfileKeys, key)
		VMRT["ProfileKeys"][key] = "Eltreum"
	else
		if E.Retail then
			VMRT = {
				["Note"] = {
					["BlackNames"] = {
					},
					["Strata"] = "BACKGROUND",
					["AutoLoad"] = {
					},
					["Left"] = 194.98414611816,
					["SelfText"] = "",
					["Fix"] = true,
					["OnlyPromoted"] = true,
					["ScaleBack"] = 0,
					["Text1"] = " ",
					["OptionsFormatting"] = true,
					["enabled"] = true,
					["DefName"] = "Personal Sounds",
					["SaveAllNew"] = true,
					["LastUpdateName"] = "Blizzard",
					["Alpha"] = 100,
					["EnableWhenReceive"] = true,
					["LastUpdateTime"] = 1612946409,
					["Width"] = 361.0000305175781,
					["BlackLastUpdateName"] = {
					},
					["Black"] = {
						"", -- [1]
						"", -- [2]
						"", -- [3]
					},
					["BlackLastUpdateTime"] = {
					},
					["Top"] = 1043.4920654297,
					["Height"] = 819.0000610351562,
					["FontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
					["FontSize"] = 14,
					["Outline"] = true,
				},
				["ProfileKeys"] = {
					[E.mynameRealm] = "Eltreum",
				},
				["Encounter"] = {
					["list"] = {
						["Addontesting"] = {
						},
						["Luaerror"] = {
						},
						["Eltreum"] = {
						},
					},
					["names"] = {
					},
				},
				["InviteTool"] = {
					["Words"] = "",
					["AutoPromote"] = true,
					["InvByChat"] = true,
					["RaidDiff"] = 16,
					["PromoteRank"] = 2,
					["Ranks"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
					},
					["LootThreshold"] = 2,
					["MasterLooters"] = "",
					["LootMethod"] = "group",
					["PromoteNames"] = "",
					["OnlyGuild"] = true,
					["Rank"] = 1,
				},
				["ExCD2"] = {
					["enabled"] = true,
					["upd4525"] = true,
					["userDB"] = {
					},
					["gnGUIDs"] = {
						["Addontesting"] = 265,
						["Luaerror"] = 73,
					},
					["Profiles"] = {
						["Now"] = "default",
						["List"] = {
						},
					},
					["CDECol"] = {
						["64044;4"] = 5,
						["32375;1"] = 2,
						["192077;1"] = 3,
						["122278;2"] = 4,
						["191427;2"] = 4,
						["29166;2"] = 2,
						["55233;2"] = 4,
						["6358;4"] = 5,
						["107570;3"] = 5,
						["31884;4"] = 3,
						["6789;2"] = 5,
						["105809;3"] = 10,
						["115078;3"] = 5,
						["15286;4"] = 2,
						["190925;4"] = 6,
						["29166;5"] = 2,
						["61336;3"] = 4,
						["51052;4"] = 2,
						["31821;2"] = 2,
						["115078;2"] = 5,
						["108238;2"] = 4,
						["152262;3"] = 2,
						["211881;2"] = 5,
						["32375;2"] = 2,
						["187650;1"] = 5,
						["105809;1"] = 2,
						["61999;4"] = 1,
						["114158;2"] = 2,
						["121536;2"] = 6,
						["49576;2"] = 6,
						["6544;2"] = 6,
						["16191;4"] = 2,
						["10060;1"] = 6,
						["221562;2"] = 5,
						["89766;2"] = 5,
						["49576;4"] = 6,
						["97462;3"] = 2,
						["6789;1"] = 5,
						["1850;5"] = 6,
						["99;4"] = 5,
						["212653;4"] = 6,
						["187707;4"] = 5,
						["642;4"] = 4,
						["115268;2"] = 5,
						["108238;5"] = 4,
						["115310;4"] = 2,
						["1850;2"] = 6,
						["190784;2"] = 6,
						["122278;3"] = 4,
						["49576;3"] = 6,
						["121536;3"] = 6,
						["4987;2"] = 2,
						["2094;1"] = 5,
						["20707;3"] = 1,
						["48265;1"] = 6,
						["51052;3"] = 2,
						["1850;3"] = 6,
						["109964;2"] = 2,
						["200183;3"] = 2,
						["6544;3"] = 6,
						["107570;1"] = 5,
						["195072;2"] = 6,
						["97462;1"] = 2,
						["45438;4"] = 4,
						["202137;3"] = 5,
						["19577;2"] = 5,
						["106898;3"] = 3,
						["5211;5"] = 5,
						["161642;1"] = 1,
						["212653;3"] = 6,
						["152262;2"] = 2,
						["246287;2"] = 2,
						["58875;3"] = 6,
						["109132;3"] = 6,
						["217832;1"] = 5,
						["20608;4"] = 1,
						["212552;3"] = 6,
						["642;2"] = 4,
						["212653;2"] = 6,
						["5211;4"] = 5,
						["116841;3"] = 3,
						["19236;1"] = 2,
						["115008;4"] = 6,
						["642;3"] = 4,
						["252216;1"] = 6,
						["99;3"] = 5,
						["186257;4"] = 6,
						["252216;3"] = 6,
						["89766;3"] = 5,
						["31884;3"] = 3,
						["49576;1"] = 6,
						["212552;2"] = 6,
						["20608;1"] = 1,
						["116841;4"] = 3,
						["152262;4"] = 2,
						["213644;3"] = 2,
						["1776;3"] = 5,
						["20707;4"] = 1,
						["119996;1"] = 6,
						["116705;3"] = 5,
						["6789;3"] = 5,
						["740;5"] = 2,
						["107570;4"] = 5,
						["61999;1"] = 1,
						["119996;2"] = 6,
						["1953;4"] = 6,
						["132409;2"] = 5,
						["252216;4"] = 6,
						["5484;4"] = 5,
						["47536;2"] = 2,
						["107570;2"] = 5,
						["187650;2"] = 5,
						["61999;2"] = 1,
						["115268;4"] = 5,
						["190784;4"] = 6,
						["6544;4"] = 6,
						["32375;4"] = 2,
						["322118;4"] = 2,
						["19236;3"] = 2,
						["207399;4"] = 1,
						["122278;4"] = 4,
						["119996;3"] = 6,
						["109132;1"] = 6,
						["2983;2"] = 6,
						["2094;3"] = 5,
						["102401;2"] = 6,
						["36554;2"] = 6,
						["190784;1"] = 6,
						["132409;4"] = 5,
						["116841;2"] = 3,
						["408;1"] = 5,
						["252216;2"] = 6,
						["115008;3"] = 6,
						["265202;3"] = 2,
						["187650;3"] = 5,
						["6358;3"] = 5,
						["10060;4"] = 6,
						["106898;4"] = 3,
						["48265;2"] = 6,
						["1953;1"] = 6,
						["216331;2"] = 2,
						["197721;5"] = 2,
						["15487;4"] = 5,
						["187650;4"] = 5,
						["99;5"] = 5,
						["5211;1"] = 5,
						["61999;3"] = 1,
						["102558;4"] = 4,
						["152262;1"] = 2,
						["186257;2"] = 6,
						["109132;4"] = 6,
						["45438;3"] = 4,
						["64843;3"] = 2,
						["105809;2"] = 2,
						["102401;5"] = 6,
						["116841;1"] = 3,
						["48265;3"] = 6,
						["20608;3"] = 1,
						["19577;4"] = 5,
						["20707;2"] = 1,
						["64901;3"] = 2,
						["122278;1"] = 4,
						["2050;3"] = 2,
						["192077;2"] = 3,
						["6358;2"] = 5,
						["1161;4"] = 4,
						["196555;2"] = 4,
						["102401;1"] = 6,
						["1161;2"] = 4,
						["642;1"] = 4,
						["99;1"] = 5,
						["89766;1"] = 5,
						["106898;1"] = 3,
						["34433;2"] = 2,
						["5211;2"] = 5,
						["115008;2"] = 6,
						["19236;4"] = 2,
						["114052;4"] = 2,
						["108199;2"] = 6,
						["97462;4"] = 2,
						["192077;4"] = 3,
						["105809;4"] = 10,
						["10060;3"] = 6,
						["198838;4"] = 2,
						["115268;1"] = 5,
						["217832;2"] = 5,
						["196718;2"] = 2,
						["1161;1"] = 4,
						["214202;2"] = 2,
						["190784;3"] = 6,
						["214621;2"] = 2,
						["98008;4"] = 2,
						["1953;3"] = 6,
						["1953;2"] = 6,
						["115078;1"] = 5,
						["45438;2"] = 4,
						["20707;1"] = 1,
						["408;2"] = 5,
						["1161;3"] = 4,
						["5211;3"] = 5,
						["108238;1"] = 4,
						["147362;2"] = 5,
						["203720;3"] = 4,
						["408;3"] = 5,
						["99;2"] = 5,
						["101545;3"] = 6,
						["34433;4"] = 2,
						["6789;4"] = 5,
						["62618;2"] = 2,
						["5484;2"] = 5,
						["20608;2"] = 1,
						["5484;3"] = 5,
						["155835;4"] = 4,
						["48265;4"] = 6,
						["2983;1"] = 6,
						["108238;3"] = 4,
						["36554;4"] = 6,
						["408;4"] = 5,
						["106898;2"] = 3,
						["61336;4"] = 4,
						["108194;3"] = 5,
						["108238;4"] = 4,
						["2094;4"] = 5,
						["116705;2"] = 5,
						["10060;2"] = 6,
						["1850;4"] = 6,
						["1850;1"] = 6,
						["252216;5"] = 6,
						["186257;1"] = 6,
						["217832;3"] = 5,
						["212552;4"] = 6,
						["31935;3"] = 5,
						["6544;1"] = 6,
						["108280;4"] = 2,
						["97462;2"] = 2,
						["2983;4"] = 6,
						["32375;3"] = 2,
						["186257;3"] = 6,
						["325197;4"] = 2,
						["114165;2"] = 2,
						["213644;4"] = 2,
						["108194;4"] = 5,
						["197908;4"] = 2,
						["89766;4"] = 5,
						["33891;5"] = 2,
						["45438;1"] = 4,
						["79206;4"] = 6,
						["106898;5"] = 3,
						["5484;1"] = 5,
						["79206;2"] = 6,
						["2094;2"] = 5,
						["212552;1"] = 6,
						["115078;4"] = 5,
						["51052;2"] = 2,
						["6358;1"] = 5,
						["115268;3"] = 5,
						["195457;3"] = 6,
						["51052;1"] = 2,
						["19236;2"] = 2,
						["212653;1"] = 6,
						["191427;3"] = 4,
						["31884;2"] = 3,
						["192077;3"] = 3,
						["147362;3"] = 5,
						["109132;2"] = 6,
						["119996;4"] = 6,
						["115008;1"] = 6,
						["2983;3"] = 6,
						["206931;2"] = 4,
						["102401;3"] = 6,
						["102401;4"] = 6,
					},
					["upd4380"] = true,
					["Top"] = 206.34968566894,
					["Left"] = 0.031815204769373,
					["Save"] = {
					},
					["lock"] = true,
					["colSet"] = {
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 70,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [1]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 69,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [2]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 65,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [3]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [4]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [5]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [6]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [7]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [8]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [9]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [10]
						{
							["textureSmoothAnimation"] = true,
							["textureColorBackgroundActiveR"] = 0,
							["methodsAlphaNotInRange"] = true,
							["textureColorBackgroundCooldownR"] = 0,
							["frameBetweenLines"] = 1,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["textureColorBackgroundDefaultG"] = 1,
							["frameLines"] = 13,
							["visibilityDisableBG"] = true,
							["textureColorTimeLineCooldownG"] = 0,
							["fontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
							["blacklistGeneral"] = true,
							["methodsShownOnCD"] = true,
							["textureColorBackgroundActiveG"] = 1,
							["methodsLineClick"] = true,
							["textureAlphaBackground"] = 0.7,
							["textureAnimation"] = true,
							["textureColorTimeLineCooldownB"] = 0,
							["fontSize"] = 12,
							["visibilityDisableWorld"] = true,
							["methodsLineClickWhisper"] = true,
							["methodsSortActiveToTop"] = true,
							["textureColorTimeLineCooldownR"] = 1,
							["textureColorBackgroundDefaultR"] = 0,
							["textureFile"] = "Interface\\AddOns\\ElvUI\\Core\\Media\\Textures\\NormTex2",
							["fontShadow"] = false,
							["iconGlowType"] = 1,
							["textureClassTimeLine"] = true,
							["textureBorderSize"] = 1,
							["frameAnchorBottom"] = true,
							["methodsTimeLineAnimation"] = 1,
							["textureAlphaTimeLine"] = 1,
							["methodsOnlyInCombat"] = true,
							["textureColorBackgroundCooldownG"] = 0,
							["textureColorBackgroundCooldownB"] = 0,
							["textureColorBackgroundDefaultB"] = 0,
							["textureColorBackgroundActiveB"] = 0,
							["frameWidth"] = 108,
							["visibilityDisableArena"] = true,
							["iconHideBlizzardEdges"] = true,
							["textureAlphaCooldown"] = 1,
						}, -- [11]
					},
					["Priority"] = {
					},
					["CDE"] = {
						[115268] = true,
						[33891] = true,
						[16191] = true,
						[116705] = true,
						[207399] = true,
						[20707] = true,
						[106839] = true,
						[6544] = true,
						[5211] = true,
						[47528] = true,
						[47536] = true,
						[49576] = true,
						[89766] = true,
						[6358] = true,
						[20608] = true,
						[116849] = true,
						[58875] = true,
						[147362] = true,
						[57994] = true,
						[221562] = true,
						[196718] = true,
						[217832] = true,
						[1766] = true,
						[1022] = true,
						[61336] = true,
						[115310] = true,
						[62618] = true,
						[105809] = true,
						[61999] = true,
						[187707] = true,
						[6552] = true,
						[6789] = true,
						[211881] = true,
						[5484] = true,
						[642] = true,
						[33206] = true,
						[108199] = true,
						[186257] = true,
						[31850] = true,
						[190784] = true,
						[19647] = true,
						[1776] = true,
						[47585] = true,
						[187650] = true,
						[2983] = true,
						[45438] = true,
						[498] = true,
						[322118] = true,
						[98008] = true,
						[2094] = true,
						[102342] = true,
						[15286] = true,
						[202137] = true,
						[64901] = true,
						[1850] = true,
						[106898] = true,
						[32375] = true,
						[19577] = true,
						[48792] = true,
						[200183] = true,
						[99] = true,
						[64044] = true,
						[108280] = true,
						[115781] = true,
						[96231] = true,
						[107570] = true,
						[23920] = true,
						[97462] = true,
						[408] = true,
						[132409] = true,
						[20484] = true,
						[114052] = true,
						[12975] = true,
						[47788] = true,
						[86659] = true,
						[161642] = true,
						[740] = true,
						[102558] = true,
						[10060] = true,
						[79206] = true,
						[115078] = true,
						[19236] = true,
						[186265] = true,
						[108194] = true,
						[194679] = true,
						[48265] = true,
						[115203] = true,
						[31821] = true,
						[1161] = true,
						[197721] = true,
						[325197] = true,
						[197908] = true,
						[78675] = true,
						[29166] = true,
						[265202] = true,
						[871] = true,
						[192077] = true,
						[2139] = true,
						[15487] = true,
						[1160] = true,
						[183752] = true,
						[633] = true,
						[64843] = true,
						[191427] = true,
						[51052] = true,
						[49028] = true,
					},
					["OptFav"] = {
					},
				},
				["Attendance"] = {
					["data"] = {
					},
					["alts"] = {
					},
				},
				["Inspect"] = {
					["Soulbinds"] = {
					},
				},
				["InspectViewer"] = {
					["ColorizeLowIlvl685"] = false,
					["ColorizeNoEnch"] = true,
					["HideNotInRaid"] = true,
					["ColorizeLowIlvl"] = true,
					["ColorizeNoGems"] = true,
					["ColorizeNoTopEnchGems"] = true,
					["ColorizeNoValorUpgrade"] = false,
				},
				["RaidCheck"] = {
					["BuffsCheck"] = true,
					["ReadyCheckLeft"] = 66.903800964355,
					["ReadyCheckFrameTimerFade"] = 4,
					["ReadyCheck"] = true,
					["PotionCheck"] = true,
					["FlaskExp"] = 2,
					["RCW_Mini"] = false,
					["ReadyCheckTop"] = 595.79650878906,
					["WeaponEnch"] = {
					},
					["disableLFR"] = true,
					["SendSelf"] = true,
					["ReadyCheckFrameScale"] = 141,
				},
				["WhoPulled"] = {
				},
				["Timers"] = {
					["specTimes"] = {
						[62] = 10,
						[63] = 10,
						[250] = 10,
						[251] = 10,
						[64] = 10,
						[253] = 10,
						[65] = 10,
						[255] = 10,
						[66] = 10,
						[257] = 10,
						[258] = 10,
						[259] = 10,
						[260] = 10,
						[261] = 25,
						[262] = 16,
						[263] = 10,
						[264] = 10,
						[265] = 22,
						[266] = 10,
						[267] = 10,
						[268] = 10,
						[269] = 10,
						[270] = 10,
						[70] = 10,
						[102] = 10,
						[71] = 10,
						[103] = 10,
						[72] = 10,
						[104] = 10,
						[73] = 10,
						[581] = 10,
						[105] = 10,
						[577] = 10,
						[256] = 10,
						[254] = 10,
						[252] = 10,
					},
					["Type"] = 1,
					["timeToKillAnalyze"] = 20,
					["timeToKill"] = true,
					["Top"] = 113.20086669922,
					["Left"] = 1627.7690429688,
					["Strata"] = "HIGH",
					["enabled"] = true,
					["DisableRW"] = true,
					["Alpha"] = 100,
					["Scale"] = 90,
					["OnlyInCombat"] = true,
				},
				["Addon"] = {
					["migrateMRT"] = true,
					["Version"] = 4620,
					["Scale"] = 1,
					["IconMiniMapHide"] = true,
					["Timer"] = 0.1,
					["PreVersion"] = 4620,
				},
				["Marks"] = {
					["list"] = {
					},
				},
				["BossWatcher"] = {
					["optionsDamageGraph"] = true,
					["fightsNum"] = 2,
					["optionsPositionsDist"] = true,
					["optionsHealingGraph"] = true,
					["trackingDamageSpells"] = {
					},
				},
				["LootHistory"] = {
					["list"] = {
					},
					["bossNames"] = {
					},
					["instanceNames"] = {
					},
				},
				["Profile"] = "Eltreum",
				["LootLink"] = {
				},
				["RaidGroups"] = {
					["KeepPosInGroup"] = true,
					["upd4550"] = true,
					["importType"] = 4,
					["profiles"] = {
					},
				},
				["Profiles"] = {
					["Eltreum"] = {
					},
				},
				["Logging"] = {
					["enable5ppLegion"] = true,
					["enableLFR"] = true,
					["enabled"] = true,
				},
				["MarksBar"] = {
					["Show"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
						true, -- [4]
						true, -- [5]
					},
					["Strata"] = "HIGH",
					["pulltimer"] = 10,
					["Top"] = 1097.1428222656,
					["Left"] = 881.99224853516,
					["pulltimer_right"] = 10,
				},
				["VisNote"] = {
					["data"] = {
						{
							"600DEC3E9C1605932626", -- [1]
						}, -- [1]
						{
							"600DEBE0B71606093531", -- [1]
							93, -- [2]
						}, -- [2]
					},
					["sync_data"] = {
					},
				},
				["BattleRes"] = {
					["Strata"] = "HIGH",
				},
			}
		elseif E.Classic then
			VMRT = {
				["Note"] = {
					["BlackNames"] = {
						[4] = "Personal Sounds*",
					},
					["Strata"] = "BACKGROUND",
					["AutoLoad"] = {
					},
					["Left"] = 194.98414611816,
					["SelfText"] = "",
					["Fix"] = true,
					["OnlyPromoted"] = true,
					["ScaleBack"] = 0,
					["Text1"] = " ",
					["OptionsFormatting"] = true,
					["enabled"] = true,
					["DefName"] = "Personal Sounds",
					["SaveAllNew"] = true,
					["LastUpdateName"] = "Eltreum",
					["Alpha"] = 100,
					["EnableWhenReceive"] = true,
					["LastUpdateTime"] = 1644110783,
					["Width"] = 361.0000305175781,
					["BlackLastUpdateName"] = {
						[4] = "Eltreum",
					},
					["BlackLastUpdateTime"] = {
						[4] = 1644110783,
					},
					["Black"] = {
						"", -- [1]
						"", -- [2]
						"", -- [3]
						" ", -- [4]
					},
					["Top"] = 1043.4920654297,
					["Height"] = 819.0000610351562,
					["FontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
					["FontSize"] = 14,
					["Outline"] = true,
				},
				["ProfileKeys"] = {
					[E.mynameRealm] = "Eltreum",
				},
				["Encounter"] = {
					["list"] = {
						["Eltreum"] = {
						},
					},
					["names"] = {
					},
				},
				["InviteTool"] = {
					["Words"] = "",
					["AutoPromote"] = true,
					["InvByChat"] = true,
					["RaidDiff"] = 16,
					["PromoteRank"] = 2,
					["Ranks"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
					},
					["LootThreshold"] = 2,
					["MasterLooters"] = "",
					["LootMethod"] = "group",
					["PromoteNames"] = "",
					["OnlyGuild"] = true,
					["Rank"] = 1,
				},
				["ExCD2"] = {
					["enabled"] = true,
					["upd4525"] = true,
					["gnGUIDs"] = {
						["Eltreum"] = 0,
					},
					["upd4380"] = true,
					["userDB"] = {
					},
					["CDECol"] = {
						["64044;4"] = 5,
						["132409;2"] = 5,
						["5484;4"] = 5,
						["97462;4"] = 2,
						["107570;2"] = 5,
						["187650;2"] = 5,
						["61999;2"] = 1,
						["29166;2"] = 3,
						["55233;2"] = 4,
						["115268;4"] = 5,
						["107570;3"] = 5,
						["31884;4"] = 3,
						["6789;2"] = 4,
						["51052;2"] = 2,
						["115078;3"] = 5,
						["15286;4"] = 2,
						["115078;4"] = 5,
						["19752;1"] = 4,
						["19236;3"] = 2,
						["207399;4"] = 1,
						["20608;2"] = 1,
						["115078;2"] = 5,
						["108238;2"] = 4,
						["5484;1"] = 5,
						["106898;5"] = 3,
						["408;4"] = 5,
						["106898;2"] = 3,
						["33891;5"] = 2,
						["132409;4"] = 5,
						["61999;4"] = 1,
						["116841;2"] = 3,
						["408;1"] = 5,
						["10060;1"] = 7,
						["265202;3"] = 2,
						["89766;2"] = 5,
						["187650;3"] = 5,
						["6358;3"] = 5,
						["97462;3"] = 2,
						["10060;4"] = 7,
						["6789;1"] = 4,
						["106898;4"] = 3,
						["99;4"] = 5,
						["187707;4"] = 5,
						["216331;2"] = 2,
						["2094;4"] = 5,
						["15487;4"] = 5,
						["187650;4"] = 5,
						["99;5"] = 5,
						["5211;1"] = 5,
						["61999;3"] = 1,
						["115268;2"] = 5,
						["108238;5"] = 4,
						["6789;4"] = 4,
						["64843;3"] = 2,
						["105809;2"] = 2,
						["355;1"] = 3,
						["116841;1"] = 3,
						["99;2"] = 5,
						["5209;1"] = 3,
						["20608;3"] = 1,
						["19577;4"] = 5,
						["115268;3"] = 5,
						["64901;3"] = 2,
						["196718;2"] = 2,
						["2050;3"] = 2,
						["217832;2"] = 5,
						["2094;1"] = 5,
						["6358;2"] = 5,
						["51052;3"] = 2,
						["109964;2"] = 2,
						["196555;2"] = 4,
						["200183;3"] = 2,
						["6358;4"] = 5,
						["107570;1"] = 5,
						["642;1"] = 4,
						["97462;1"] = 2,
						["45438;4"] = 4,
						["106898;1"] = 3,
						["105809;3"] = 2,
						["19577;2"] = 5,
						["106898;3"] = 3,
						["5211;5"] = 5,
						["45438;3"] = 4,
						["29166;5"] = 3,
						["19236;2"] = 2,
						["192077;4"] = 3,
						["161642;1"] = 1,
						["192077;2"] = 3,
						["642;4"] = 4,
						["115268;1"] = 5,
						["122278;2"] = 4,
						["20707;3"] = 1,
						["1161;1"] = 3,
						["61999;1"] = 1,
						["2094;3"] = 5,
						["20765;1"] = 2,
						["98008;4"] = 2,
						["192077;1"] = 3,
						["217832;1"] = 5,
						["115078;1"] = 5,
						["45438;2"] = 4,
						["20707;1"] = 1,
						["408;2"] = 5,
						["107570;4"] = 5,
						["5211;3"] = 5,
						["108238;1"] = 4,
						["97462;2"] = 2,
						["740;5"] = 2,
						["408;3"] = 5,
						["5211;4"] = 5,
						["116841;3"] = 3,
						["19236;1"] = 2,
						["31821;2"] = 2,
						["62618;2"] = 2,
						["5484;2"] = 5,
						["642;3"] = 4,
						["5484;3"] = 5,
						["211881;2"] = 5,
						["99;3"] = 5,
						["108280;4"] = 2,
						["108238;3"] = 4,
						["6789;3"] = 4,
						["116705;3"] = 5,
						["105809;1"] = 2,
						["61336;4"] = 4,
						["108194;3"] = 5,
						["108238;4"] = 4,
						["5211;2"] = 5,
						["116705;2"] = 5,
						["10060;2"] = 7,
						["20608;4"] = 1,
						["31884;3"] = 3,
						["10060;3"] = 7,
						["51052;4"] = 2,
						["45438;1"] = 4,
						["116841;4"] = 3,
						["31935;3"] = 5,
						["89766;4"] = 5,
						["20608;1"] = 1,
						["6795;1"] = 3,
						["147362;2"] = 5,
						["108194;4"] = 5,
						["1776;3"] = 5,
						["20707;2"] = 1,
						["187650;1"] = 5,
						["19236;4"] = 2,
						["217832;3"] = 5,
						["642;2"] = 4,
						["17359;1"] = 1,
						["11958;1"] = 4,
						["99;1"] = 5,
						["89766;3"] = 5,
						["6358;1"] = 5,
						["20707;4"] = 1,
						["221562;2"] = 5,
						["2094;2"] = 5,
						["89766;1"] = 5,
						["192077;3"] = 3,
						["115310;4"] = 2,
						["47536;2"] = 2,
						["191427;3"] = 4,
						["105809;4"] = 2,
						["51052;1"] = 2,
						["12975;1"] = 4,
						["61336;3"] = 4,
						["191427;2"] = 4,
						["31884;2"] = 3,
						["122278;1"] = 4,
						["147362;3"] = 5,
						["122278;4"] = 4,
						["871;1"] = 4,
						["1020;1"] = 4,
						["10310;1"] = 4,
						["122278;3"] = 4,
						["20748;1"] = 2,
						["9863;1"] = 2,
					},
					["Profiles"] = {
						["Now"] = "default",
						["List"] = {
						},
					},
					["Top"] = 206.34968566894,
					["Left"] = 0.031815204769373,
					["Save"] = {
					},
					["lock"] = true,
					["colSet"] = {
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 70,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [1]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 69,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [2]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["frameWidth"] = 65,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [3]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [4]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [5]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [6]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [7]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [8]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [9]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["fontShadow"] = false,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["textureGeneral"] = true,
						}, -- [10]
						{
							["textureSmoothAnimation"] = true,
							["textureColorBackgroundActiveR"] = 0,
							["methodsAlphaNotInRange"] = true,
							["textureColorBackgroundCooldownR"] = 0,
							["frameBetweenLines"] = 1,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["textureColorBackgroundDefaultG"] = 1,
							["frameLines"] = 13,
							["visibilityDisableBG"] = true,
							["textureColorTimeLineCooldownG"] = 0,
							["fontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
							["blacklistGeneral"] = true,
							["methodsShownOnCD"] = true,
							["textureColorBackgroundActiveG"] = 1,
							["methodsLineClick"] = true,
							["textureAlphaBackground"] = 0.7,
							["textureAnimation"] = true,
							["textureColorTimeLineCooldownB"] = 0,
							["fontSize"] = 12,
							["methodsLineClickWhisper"] = true,
							["methodsSortActiveToTop"] = true,
							["textureColorTimeLineCooldownR"] = 1,
							["textureColorBackgroundDefaultR"] = 0,
							["fontShadow"] = false,
							["textureClassTimeLine"] = true,
							["iconGlowType"] = 1,
							["methodsTimeLineAnimation"] = 1,
							["textureBorderSize"] = 1,
							["frameAnchorBottom"] = true,
							["textureAlphaTimeLine"] = 1,
							["textureFile"] = "Interface\\AddOns\\ElvUI\\Core\\Media\\Textures\\NormTex2",
							["methodsOnlyInCombat"] = true,
							["textureColorBackgroundCooldownG"] = 0,
							["textureColorBackgroundCooldownB"] = 0,
							["textureColorBackgroundDefaultB"] = 0,
							["textureColorBackgroundActiveB"] = 0,
							["frameWidth"] = 108,
							["visibilityDisableArena"] = true,
							["iconHideBlizzardEdges"] = true,
							["textureAlphaCooldown"] = 1,
						}, -- [11]
					},
					["Priority"] = {
					},
					["CDE"] = {
						[115268] = true,
						[33891] = true,
						[16191] = true,
						[116705] = true,
						[207399] = true,
						[20707] = true,
						[106839] = true,
						[5211] = true,
						[47528] = true,
						[89766] = true,
						[6358] = true,
						[20608] = true,
						[147362] = true,
						[57994] = true,
						[221562] = true,
						[196718] = true,
						[217832] = true,
						[1766] = true,
						[115310] = true,
						[62618] = true,
						[61999] = true,
						[211881] = true,
						[5484] = true,
						[642] = true,
						[355] = true,
						[183752] = true,
						[45438] = true,
						[498] = true,
						[98008] = true,
						[64901] = true,
						[6552] = true,
						[19647] = true,
						[187707] = true,
						[108280] = true,
						[115781] = true,
						[96231] = true,
						[6795] = true,
						[20765] = true,
						[1776] = true,
						[99] = true,
						[187650] = true,
						[20484] = true,
						[11958] = true,
						[12975] = true,
						[19577] = true,
						[10310] = true,
						[20748] = true,
						[15286] = true,
						[740] = true,
						[10060] = true,
						[47585] = true,
						[51052] = true,
						[19236] = true,
						[186265] = true,
						[108194] = true,
						[115078] = true,
						[19752] = true,
						[15487] = true,
						[408] = true,
						[106898] = true,
						[107570] = true,
						[871] = true,
						[97462] = true,
						[64044] = true,
						[29166] = true,
						[265202] = true,
						[17359] = true,
						[192077] = true,
						[2139] = true,
						[1161] = true,
						[161642] = true,
						[1020] = true,
						[2094] = true,
						[64843] = true,
						[6789] = true,
						[9863] = true,
						[5209] = true,
					},
					["OptFav"] = {
					},
				},
				["Attendance"] = {
					["alts"] = {
					},
					["data"] = {
					},
					["enabled"] = 2,
				},
				["Inspect"] = {
					["Soulbinds"] = {
					},
				},
				["InspectViewer"] = {
					["ColorizeLowIlvl685"] = false,
					["ColorizeNoEnch"] = true,
					["HideNotInRaid"] = true,
					["ColorizeLowIlvl"] = true,
					["ColorizeNoGems"] = true,
					["ColorizeNoTopEnchGems"] = true,
					["ColorizeNoValorUpgrade"] = false,
				},
				["RaidCheck"] = {
					["WeaponEnch"] = {
					},
					["disableLFR"] = true,
					["BuffsCheck"] = true,
					["ReadyCheckFrame"] = true,
					["ReadyCheckFrameTimerFade"] = 4,
					["ReadyCheck"] = true,
					["PotionCheck"] = true,
					["SendSelf"] = true,
					["FlaskExp"] = 2,
					["ReadyCheckTop"] = 972.5331420898438,
					["ReadyCheckFont"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
					["ReadyCheckFrameScale"] = 90,
					["ReadyCheckSortClass"] = true,
					["RCW_Mini"] = false,
					["ReadyCheckFontSize"] = 16,
					["ReadyCheckLeft"] = 683.459716796875,
				},
				["WhoPulled"] = {
				},
				["Timers"] = {
					["specTimes"] = {
						[62] = 10,
						[63] = 10,
						[250] = 10,
						[251] = 10,
						[64] = 10,
						[253] = 10,
						[65] = 10,
						[255] = 10,
						[66] = 10,
						[257] = 10,
						[258] = 10,
						[259] = 10,
						[260] = 10,
						[261] = 25,
						[262] = 16,
						[263] = 10,
						[264] = 10,
						[265] = 22,
						[266] = 10,
						[267] = 10,
						[268] = 10,
						[269] = 10,
						[270] = 10,
						[70] = 10,
						[102] = 10,
						[71] = 10,
						[103] = 10,
						[72] = 10,
						[104] = 10,
						[73] = 10,
						[581] = 10,
						[105] = 10,
						[577] = 10,
						[256] = 10,
						[254] = 10,
						[252] = 10,
					},
					["Type"] = 1,
					["timeToKillAnalyze"] = 20,
					["timeToKill"] = true,
					["Alpha"] = 100,
					["Top"] = 806.0771484375,
					["Strata"] = "HIGH",
					["enabled"] = true,
					["Lock"] = true,
					["DisableRW"] = true,
					["Scale"] = 108,
					["Left"] = 1613.535888671875,
					["OnlyInCombat"] = true,
				},
				["Addon"] = {
					["migrateMRT"] = true,
					["Version"] = 4600,
					["Scale"] = 1,
					["IconMiniMapHide"] = true,
					["Timer"] = 0.1,
					["PreVersion"] = 4600,
				},
				["Marks"] = {
					["list"] = {
					},
				},
				["BossWatcher"] = {
					["optionsDamageGraph"] = true,
					["fightsNum"] = 2,
					["trackingDamageSpells"] = {
					},
					["optionsPositionsDist"] = true,
					["optionsHealingGraph"] = true,
					["enabled"] = true,
				},
				["LootHistory"] = {
					["list"] = {
					},
					["bossNames"] = {
					},
					["instanceNames"] = {
					},
				},
				["Profile"] = "Eltreum",
				["LootLink"] = {
					["enabled"] = true,
				},
				["RaidGroups"] = {
					["KeepPosInGroup"] = true,
					["upd4550"] = true,
					["importType"] = 4,
					["profiles"] = {
					},
				},
				["Profiles"] = {
					["Eltreum"] = {
					},
				},
				["Logging"] = {
					["enable5ppLegion"] = true,
					["enableLFR"] = true,
					["enabled"] = true,
				},
				["MarksBar"] = {
					["enabled"] = true,
					["Strata"] = "HIGH",
					["DisableOutsideRaid"] = true,
					["Left"] = 374.0554504394531,
					["Top"] = 1097.142822265625,
					["pulltimer_right"] = 30,
					["DisableWithoutAssist"] = true,
					["pulltimer"] = 10,
					["Show"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
						true, -- [4]
						true, -- [5]
					},
				},
				["VisNote"] = {
					["data"] = {
						{
							"600DEC3E9C1605932626", -- [1]
						}, -- [1]
						{
							"600DEBE0B71606093531", -- [1]
							93, -- [2]
						}, -- [2]
					},
					["sync_data"] = {
					},
				},
				["BattleRes"] = {
					["Strata"] = "HIGH",
				},
			}
		elseif E.Wrath then
			VMRT = {
				["Note"] = {
					["BlackNames"] = {
						[4] = "Personal Sounds*",
					},
					["Strata"] = "BACKGROUND",
					["AutoLoad"] = {
					},
					["Left"] = 194.98414611816,
					["SelfText"] = "",
					["Fix"] = true,
					["Outline"] = true,
					["ScaleBack"] = 0,
					["Text1"] = " ",
					["OptionsFormatting"] = true,
					["enabled"] = true,
					["FontSize"] = 14,
					["SaveAllNew"] = true,
					["LastUpdateName"] = "Eltreum",
					["Alpha"] = 100,
					["BlackLastUpdateName"] = {
						[4] = "Eltreum",
					},
					["LastUpdateTime"] = 1644111858,
					["Width"] = 361.0000305175781,
					["EnableWhenReceive"] = true,
					["Top"] = 1043.4920654297,
					["Black"] = {
						"", -- [1]
						"", -- [2]
						"", -- [3]
						" ", -- [4]
					},
					["BlackLastUpdateTime"] = {
						[4] = 1644111858,
					},
					["Height"] = 819.0000610351562,
					["FontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
					["DefName"] = "Personal Sounds",
					["OnlyPromoted"] = true,
				},
				["ProfileKeys"] = {
					[E.mynameRealm] = "Eltreum",
				},
				["Encounter"] = {
					["names"] = {
					},
					["list"] = {
						["Eltreum"] = {
						},
					},
				},
				["InviteTool"] = {
					["Words"] = "",
					["AutoPromote"] = true,
					["InvByChat"] = true,
					["RaidDiff"] = 16,
					["PromoteRank"] = 2,
					["Ranks"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
					},
					["LootThreshold"] = 2,
					["MasterLooters"] = "",
					["LootMethod"] = "group",
					["PromoteNames"] = "",
					["OnlyGuild"] = true,
					["Rank"] = 1,
				},
				["ExCD2"] = {
					["enabled"] = true,
					["upd4525"] = true,
					["gnGUIDs"] = {
						["Eltreum"] = 0,
					},
					["Profiles"] = {
						["Now"] = "default",
						["List"] = {
						},
					},
					["userDB"] = {
					},
					["CDECol"] = {
						["64044;4"] = 5,
						["132409;2"] = 5,
						["5484;4"] = 5,
						["97462;4"] = 2,
						["107570;2"] = 5,
						["187650;2"] = 5,
						["61999;2"] = 1,
						["29166;2"] = 3,
						["55233;2"] = 4,
						["115268;4"] = 5,
						["107570;3"] = 5,
						["31884;4"] = 3,
						["6789;2"] = 4,
						["51052;2"] = 2,
						["115078;3"] = 5,
						["15286;4"] = 2,
						["115078;4"] = 5,
						["19752;1"] = 4,
						["19236;3"] = 2,
						["207399;4"] = 1,
						["20608;2"] = 1,
						["115078;2"] = 5,
						["108238;2"] = 4,
						["5484;1"] = 5,
						["106898;5"] = 3,
						["408;4"] = 5,
						["106898;2"] = 3,
						["33891;5"] = 2,
						["132409;4"] = 5,
						["61999;4"] = 1,
						["116841;2"] = 3,
						["408;1"] = 5,
						["10060;1"] = 7,
						["265202;3"] = 2,
						["89766;2"] = 5,
						["187650;3"] = 5,
						["6358;3"] = 5,
						["97462;3"] = 2,
						["10060;4"] = 7,
						["6789;1"] = 4,
						["106898;4"] = 3,
						["99;4"] = 5,
						["187707;4"] = 5,
						["216331;2"] = 2,
						["2094;4"] = 5,
						["15487;4"] = 5,
						["187650;4"] = 5,
						["99;5"] = 5,
						["5211;1"] = 5,
						["61999;3"] = 1,
						["115268;2"] = 5,
						["108238;5"] = 4,
						["6789;4"] = 4,
						["64843;3"] = 2,
						["105809;2"] = 2,
						["355;1"] = 3,
						["116841;1"] = 3,
						["99;2"] = 5,
						["5209;1"] = 3,
						["20608;3"] = 1,
						["19577;4"] = 5,
						["115268;3"] = 5,
						["64901;3"] = 2,
						["196718;2"] = 2,
						["2050;3"] = 2,
						["217832;2"] = 5,
						["2094;1"] = 5,
						["6358;2"] = 5,
						["9863;1"] = 2,
						["20748;1"] = 2,
						["6346;1"] = 2,
						["51052;3"] = 2,
						["10310;1"] = 4,
						["109964;2"] = 2,
						["196555;2"] = 4,
						["1020;1"] = 4,
						["871;1"] = 4,
						["200183;3"] = 2,
						["122278;4"] = 4,
						["2825;1"] = 2,
						["122278;1"] = 4,
						["31884;2"] = 3,
						["191427;2"] = 4,
						["107570;1"] = 5,
						["642;1"] = 4,
						["97462;1"] = 2,
						["45438;4"] = 4,
						["106898;1"] = 3,
						["61336;3"] = 4,
						["19577;2"] = 5,
						["106898;3"] = 3,
						["5211;5"] = 5,
						["12975;1"] = 4,
						["192077;2"] = 3,
						["105809;4"] = 2,
						["192077;4"] = 3,
						["161642;1"] = 1,
						["191427;3"] = 4,
						["47536;2"] = 2,
						["115268;1"] = 5,
						["2094;3"] = 5,
						["32548;1"] = 2,
						["1161;1"] = 3,
						["192077;3"] = 3,
						["89766;1"] = 5,
						["20765;1"] = 2,
						["98008;4"] = 2,
						["97462;2"] = 2,
						["217832;1"] = 5,
						["115078;1"] = 5,
						["45438;2"] = 4,
						["20707;1"] = 1,
						["408;2"] = 5,
						["221562;2"] = 5,
						["5211;3"] = 5,
						["108238;1"] = 4,
						["31821;2"] = 2,
						["211881;2"] = 5,
						["408;3"] = 5,
						["5211;4"] = 5,
						["116841;3"] = 3,
						["19236;1"] = 2,
						["89766;3"] = 5,
						["62618;2"] = 2,
						["5484;2"] = 5,
						["642;3"] = 4,
						["5484;3"] = 5,
						["99;1"] = 5,
						["99;3"] = 5,
						["192077;1"] = 3,
						["108238;3"] = 4,
						["17359;1"] = 1,
						["642;2"] = 4,
						["217832;3"] = 5,
						["61336;4"] = 4,
						["108194;3"] = 5,
						["108238;4"] = 4,
						["19236;4"] = 2,
						["116705;2"] = 5,
						["10060;2"] = 7,
						["187650;1"] = 5,
						["31884;3"] = 3,
						["20707;2"] = 1,
						["1776;3"] = 5,
						["19801;1"] = 2,
						["5211;2"] = 5,
						["31935;3"] = 5,
						["147362;2"] = 5,
						["20608;1"] = 2,
						["116841;4"] = 3,
						["6795;1"] = 3,
						["108280;4"] = 2,
						["89766;4"] = 5,
						["51052;4"] = 2,
						["10060;3"] = 7,
						["20608;4"] = 1,
						["108194;4"] = 5,
						["19236;2"] = 2,
						["12809;1"] = 3,
						["11958;1"] = 1,
						["45438;1"] = 4,
						["105809;1"] = 2,
						["34477;1"] = 2,
						["20707;4"] = 1,
						["642;4"] = 4,
						["2094;2"] = 5,
						["116705;3"] = 5,
						["6789;3"] = 4,
						["32182;1"] = 2,
						["105809;3"] = 2,
						["122278;2"] = 4,
						["740;5"] = 2,
						["51052;1"] = 2,
						["107570;4"] = 5,
						["29166;5"] = 3,
						["45438;3"] = 4,
						["61999;1"] = 1,
						["6358;4"] = 5,
						["147362;3"] = 5,
						["115310;4"] = 2,
						["16190;1"] = 2,
						["6358;1"] = 5,
						["28275;1"] = 2,
						["676;1"] = 3,
						["20707;3"] = 1,
						["122278;3"] = 4,
					},
					["upd4380"] = true,
					["Top"] = 206.34968566894,
					["Left"] = 0.031815204769373,
					["Save"] = {
					},
					["lock"] = true,
					["colSet"] = {
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["textureAnimation"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["frameWidth"] = 70,
							["fontShadow"] = false,
						}, -- [1]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["textureAnimation"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["frameWidth"] = 69,
							["fontShadow"] = false,
						}, -- [2]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["textureAnimation"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["frameWidth"] = 65,
							["fontShadow"] = false,
						}, -- [3]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [4]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [5]
						{
							["enabled"] = true,
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [6]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [7]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [8]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [9]
						{
							["frameGeneral"] = true,
							["iconGray"] = true,
							["textGeneral"] = true,
							["methodsGeneral"] = true,
							["blacklistGeneral"] = true,
							["textureGeneral"] = true,
							["iconGeneral"] = true,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["fontGeneral"] = true,
							["textureAnimation"] = true,
							["fontShadow"] = false,
						}, -- [10]
						{
							["textureSmoothAnimation"] = true,
							["textureColorBackgroundActiveR"] = 0,
							["methodsAlphaNotInRange"] = true,
							["textureColorBackgroundCooldownR"] = 0,
							["frameBetweenLines"] = 1,
							["fontOutline"] = true,
							["visibilityGeneral"] = true,
							["textureColorBackgroundDefaultG"] = 1,
							["frameLines"] = 13,
							["visibilityDisableBG"] = true,
							["textureColorTimeLineCooldownG"] = 0,
							["fontName"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
							["blacklistGeneral"] = true,
							["methodsShownOnCD"] = true,
							["textureColorBackgroundActiveG"] = 1,
							["methodsLineClick"] = true,
							["textureAlphaBackground"] = 0.7,
							["textureAnimation"] = true,
							["textureColorTimeLineCooldownB"] = 0,
							["fontSize"] = 12,
							["methodsLineClickWhisper"] = true,
							["methodsSortActiveToTop"] = true,
							["textureColorTimeLineCooldownR"] = 1,
							["textureColorBackgroundDefaultR"] = 0,
							["fontShadow"] = false,
							["textureClassTimeLine"] = true,
							["iconGlowType"] = 1,
							["methodsTimeLineAnimation"] = 1,
							["textureBorderSize"] = 1,
							["frameAnchorBottom"] = true,
							["textureAlphaTimeLine"] = 1,
							["frameWidth"] = 108,
							["methodsOnlyInCombat"] = true,
							["textureColorBackgroundActiveB"] = 0,
							["textureColorBackgroundDefaultB"] = 0,
							["textureColorBackgroundCooldownB"] = 0,
							["textureColorBackgroundCooldownG"] = 0,
							["textureFile"] = "Interface\\AddOns\\ElvUI\\Core\\Media\\Textures\\NormTex2",
							["visibilityDisableArena"] = true,
							["iconHideBlizzardEdges"] = true,
							["textureAlphaCooldown"] = 1,
						}, -- [11]
					},
					["Priority"] = {
					},
					["CDE"] = {
						[6346] = true,
						[115268] = true,
						[33891] = true,
						[16190] = true,
						[16191] = true,
						[116705] = true,
						[207399] = true,
						[20707] = true,
						[106839] = true,
						[5211] = true,
						[47528] = true,
						[89766] = true,
						[6358] = true,
						[20608] = true,
						[32548] = true,
						[147362] = true,
						[57994] = true,
						[221562] = true,
						[196718] = true,
						[217832] = true,
						[1766] = true,
						[115310] = true,
						[62618] = true,
						[61999] = true,
						[211881] = true,
						[5484] = true,
						[642] = true,
						[355] = true,
						[183752] = true,
						[45438] = true,
						[498] = true,
						[2825] = true,
						[98008] = true,
						[5209] = true,
						[64901] = true,
						[9863] = true,
						[19577] = true,
						[6552] = true,
						[2094] = true,
						[1020] = true,
						[1161] = true,
						[20748] = true,
						[64044] = true,
						[108280] = true,
						[115781] = true,
						[96231] = true,
						[2139] = true,
						[192077] = true,
						[34477] = true,
						[20484] = true,
						[47585] = true,
						[676] = true,
						[11958] = true,
						[12975] = true,
						[1776] = true,
						[10310] = true,
						[161642] = true,
						[740] = true,
						[32182] = true,
						[10060] = true,
						[97462] = true,
						[871] = true,
						[19236] = true,
						[186265] = true,
						[99] = true,
						[107570] = true,
						[19752] = true,
						[106898] = true,
						[408] = true,
						[15487] = true,
						[115078] = true,
						[108194] = true,
						[51052] = true,
						[28275] = true,
						[29166] = true,
						[265202] = true,
						[17359] = true,
						[19647] = true,
						[15286] = true,
						[187650] = true,
						[20765] = true,
						[187707] = true,
						[6795] = true,
						[64843] = true,
						[6789] = true,
						[19801] = true,
						[12809] = true,
					},
					["OptFav"] = {
					},
				},
				["Attendance"] = {
					["alts"] = {
					},
					["data"] = {
					},
					["enabled"] = 2,
				},
				["Inspect"] = {
					["Soulbinds"] = {
					},
				},
				["InspectViewer"] = {
					["ColorizeLowIlvl685"] = false,
					["ColorizeNoEnch"] = true,
					["HideNotInRaid"] = true,
					["ColorizeNoTopEnchGems"] = true,
					["ColorizeNoGems"] = true,
					["ColorizeLowIlvl"] = true,
					["ColorizeNoValorUpgrade"] = false,
				},
				["BattleRes"] = {
					["Strata"] = "HIGH",
				},
				["WhoPulled"] = {
				},
				["Timers"] = {
					["specTimes"] = {
						[62] = 10,
						[63] = 10,
						[250] = 10,
						[251] = 10,
						[64] = 10,
						[253] = 10,
						[65] = 10,
						[255] = 10,
						[66] = 10,
						[257] = 10,
						[258] = 10,
						[259] = 10,
						[260] = 10,
						[261] = 25,
						[262] = 16,
						[263] = 10,
						[264] = 10,
						[265] = 22,
						[266] = 10,
						[267] = 10,
						[268] = 10,
						[269] = 10,
						[270] = 10,
						[70] = 10,
						[102] = 10,
						[71] = 10,
						[103] = 10,
						[72] = 10,
						[104] = 10,
						[73] = 10,
						[252] = 10,
						[105] = 10,
						[254] = 10,
						[256] = 10,
						[577] = 10,
						[581] = 10,
					},
					["Type"] = 1,
					["timeToKillAnalyze"] = 20,
					["timeToKill"] = true,
					["Alpha"] = 100,
					["Top"] = 806.0771484375,
					["Left"] = 1613.535888671875,
					["Scale"] = 108,
					["Lock"] = true,
					["DisableRW"] = true,
					["enabled"] = true,
					["Strata"] = "HIGH",
					["OnlyInCombat"] = true,
				},
				["Addon"] = {
					["migrateMRT"] = true,
					["Version"] = 4600,
					["Scale"] = 1,
					["PreVersion"] = 4600,
					["Timer"] = 0.1,
					["IconMiniMapHide"] = true,
				},
				["Marks"] = {
					["list"] = {
					},
				},
				["BossWatcher"] = {
					["optionsDamageGraph"] = true,
					["fightsNum"] = 2,
					["optionsPositionsDist"] = true,
					["optionsHealingGraph"] = true,
					["trackingDamageSpells"] = {
					},
				},
				["LootHistory"] = {
					["instanceNames"] = {
					},
					["bossNames"] = {
					},
					["list"] = {
					},
				},
				["Profile"] = "Eltreum",
				["LootLink"] = {
					["enabled"] = true,
				},
				["RaidGroups"] = {
					["KeepPosInGroup"] = true,
					["upd4550"] = true,
					["importType"] = 4,
					["profiles"] = {
					},
				},
				["Profiles"] = {
					["Eltreum"] = {
					},
				},
				["Logging"] = {
					["enable5ppLegion"] = true,
					["enableclassic5pplHC"] = true,
					["enableLFR"] = true,
					["enabled"] = true,
				},
				["MarksBar"] = {
					["enabled"] = true,
					["Strata"] = "HIGH",
					["DisableOutsideRaid"] = true,
					["Left"] = 374.0554504394531,
					["Top"] = 1097.142822265625,
					["pulltimer_right"] = 30,
					["DisableWithoutAssist"] = true,
					["Fix"] = true,
					["pulltimer"] = 10,
					["Show"] = {
						true, -- [1]
						true, -- [2]
						true, -- [3]
						true, -- [4]
						true, -- [5]
					},
				},
				["VisNote"] = {
					["data"] = {
						{
							"600DEC3E9C1605932626", -- [1]
						}, -- [1]
						{
							"600DEBE0B71606093531", -- [1]
							93, -- [2]
						}, -- [2]
					},
					["sync_data"] = {
					},
				},
				["RaidCheck"] = {
					["ReadyCheckFrame"] = true,
					["ReadyCheckFontSize"] = 16,
					["BuffsCheck"] = true,
					["ReadyCheckLeft"] = 697.5692138671875,
					["ReadyCheckFrameTimerFade"] = 4,
					["ReadyCheck"] = true,
					["PotionCheck"] = true,
					["ReadyCheckFont"] = "Interface\\AddOns\\ElvUI_EltreumUI\\Media\\Fonts\\Kimberley.ttf",
					["FlaskExp"] = 2,
					["ReadyCheckSortClass"] = true,
					["RCW_Mini"] = false,
					["ReadyCheckFrameScale"] = 90,
					["ReadyCheckTop"] = 990.593017578125,
					["WeaponEnch"] = {
					},
					["SendSelf"] = true,
					["disableLFR"] = true,
				},
			}
		end
	end
end
